#!/bin/sh
#
# OpenVAS
# $Id$
# Description: Escalator method script: SCP.
#
# Authors:
# Matthew Mundell <matthew.mundell@greenbone.net>
#
# Copyright:
# Copyright (C) 2016 Greenbone Networks GmbH
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.

USERNAME=$1
HOST=$2
DEST=$3
KNOWN_HOSTS=$4
PASSWORD_FILE=$5
REPORT_FILE=$6

KNOWN_HOSTS_FILE=`mktemp` || exit 1
echo $KNOWN_HOSTS > $KNOWN_HOSTS_FILE

log_error() {
  logger "SCP alert: $1"
  echo "$1" >&2
}

# Escape destination twice because it is also expanded on the remote end.
sshpass -f ${PASSWORD_FILE} scp -o HashKnownHosts=no -o UserKnownHostsFile="${KNOWN_HOSTS_FILE} ~/.ssh/known_hosts ~/.ssh/known_hosts2 /etc/ssh/ssh_known_hosts" "${REPORT_FILE}" "${USERNAME}@${HOST}:'${DEST}'" 2>/dev/null

EXIT_CODE=$?
if [ $EXIT_CODE -eq 1 ]
then
  log_error "sshpass failed with exit code ${EXIT_CODE}: Invalid command line argument"
elif [ $EXIT_CODE -eq 2 ]
then
  log_error "sshpass failed with exit code ${EXIT_CODE}: Conflicting arguments given"
elif [ $EXIT_CODE -eq 3 ]
then
  log_error "sshpass failed with exit code ${EXIT_CODE}: General runtime error"
elif [ $EXIT_CODE -eq 4 ]
then
  log_error "sshpass failed with exit code ${EXIT_CODE}: Unrecognized response from ssh (parse error)"
elif [ $EXIT_CODE -eq 5 ]
then
  log_error "sshpass failed with exit code ${EXIT_CODE}: Invalid/incorrect password"
elif [ $EXIT_CODE -eq 6 ]
then
  log_error "sshpass failed with exit code ${EXIT_CODE}: Host public key is unknown."
elif [ $EXIT_CODE -eq 127 ]
then
  log_error "sshpass failed with exit code ${EXIT_CODE}: Command not found."
elif [ $EXIT_CODE -ne 0 ]
then
  log_error "sshpass failed with exit code ${EXIT_CODE}"
fi

rm $KNOWN_HOSTS_FILE
rm $PASSWORD_FILE

exit $EXIT_CODE
